// By Mario Brito - mariobrito2@gmail.com

using System;
namespace p2huff
{
	public class BitStream
	{
		byte[] stream;
		int bitPtr;
		int available;
		
		public BitStream (byte[] stream)
		{
			if (stream == null) throw new NullReferenceException("Bitstream cannot be null!");
			
			this.stream = stream;
			this.bitPtr = 0;
			this.available = stream.Length * 8;
		}
		
		public UInt32 popBits(ref int numBits)
		{
			UInt32 reg = 0;
			
			if (numBits > available)
			{
				numBits = available;
			}
			
			int pos = bitPtr >> 3;
			int skip = bitPtr & 7;
		
			// load bits into register
			for (int i = pos; i < pos + sizeof(UInt32); ++i)
			{
				byte tmp = 0;
				
				if (i < stream.Length)
				{
					tmp = stream[i];
				}
				
				reg <<= 8;
				reg |= (((UInt32)tmp) & 0xFF);
			}
			
			// shift out extra bits
			reg <<= skip;
			reg >>= 32 - numBits;
			
			bitPtr += numBits;
			available -= numBits;
			return reg;
		}
	}
}

