// By Mario Brito - mariobrito2@gmail.com

using System;
using System.IO;

namespace p2huff.IFF
{
	// TODO: Make a proper IFF reader later...
	public class ChunkReader
	{
		FileStream fs;
		public ChunkReader (FileStream fs)
		{
			this.fs = fs;
		}
		
		public byte[] read(string tag)
		{
			byte[] buffer =  new byte[4];
			
			if (fs.Read(buffer, 0, buffer.Length) == buffer.Length)
			{
				if (
				    buffer[0] == 'T' &&
				    buffer[1] == 'X' &&
				    buffer[2] == 'T' &&
				    buffer[3] == '2'
				    )
				{
					if (fs.Read(buffer, 0, buffer.Length) == buffer.Length)
					{
						int len = ((buffer[3] & 0xFF) <<  0) |
						    	  ((buffer[2] & 0xFF) <<  8) |
						    	  ((buffer[1] & 0xFF) << 16) |
						    	  ((buffer[0] & 0xFF) << 24);
						
						System.Console.WriteLine("Found " + tag + " chunk with length " + len);
						
						byte[] ret = new byte[len];
						if (fs.Read(ret, 0, len) == len)
						{
							return ret;
						}
					}
				}
			}
			throw new WrongChunkException(tag);
		}
	}
}

